// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/iam/v3/principal_access_boundary_policies_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_INTERNAL_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_INTERNAL_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_CONNECTION_IMPL_H

#include "google/cloud/iam/v3/internal/principal_access_boundary_policies_retry_traits.h"
#include "google/cloud/iam/v3/internal/principal_access_boundary_policies_stub.h"
#include "google/cloud/iam/v3/principal_access_boundary_policies_connection.h"
#include "google/cloud/iam/v3/principal_access_boundary_policies_connection_idempotency_policy.h"
#include "google/cloud/iam/v3/principal_access_boundary_policies_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/future.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace iam_v3_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class PrincipalAccessBoundaryPoliciesConnectionImpl
    : public iam_v3::PrincipalAccessBoundaryPoliciesConnection {
 public:
  ~PrincipalAccessBoundaryPoliciesConnectionImpl() override = default;

  PrincipalAccessBoundaryPoliciesConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<iam_v3_internal::PrincipalAccessBoundaryPoliciesStub>
          stub,
      Options options);

  Options options() override { return options_; }

  future<StatusOr<google::iam::v3::PrincipalAccessBoundaryPolicy>>
  CreatePrincipalAccessBoundaryPolicy(
      google::iam::v3::CreatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> CreatePrincipalAccessBoundaryPolicy(
      NoAwaitTag,
      google::iam::v3::CreatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  future<StatusOr<google::iam::v3::PrincipalAccessBoundaryPolicy>>
  CreatePrincipalAccessBoundaryPolicy(
      google::longrunning::Operation const& operation) override;

  StatusOr<google::iam::v3::PrincipalAccessBoundaryPolicy>
  GetPrincipalAccessBoundaryPolicy(
      google::iam::v3::GetPrincipalAccessBoundaryPolicyRequest const& request)
      override;

  future<StatusOr<google::iam::v3::PrincipalAccessBoundaryPolicy>>
  UpdatePrincipalAccessBoundaryPolicy(
      google::iam::v3::UpdatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> UpdatePrincipalAccessBoundaryPolicy(
      NoAwaitTag,
      google::iam::v3::UpdatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  future<StatusOr<google::iam::v3::PrincipalAccessBoundaryPolicy>>
  UpdatePrincipalAccessBoundaryPolicy(
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::iam::v3::OperationMetadata>>
  DeletePrincipalAccessBoundaryPolicy(
      google::iam::v3::DeletePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> DeletePrincipalAccessBoundaryPolicy(
      NoAwaitTag,
      google::iam::v3::DeletePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  future<StatusOr<google::iam::v3::OperationMetadata>>
  DeletePrincipalAccessBoundaryPolicy(
      google::longrunning::Operation const& operation) override;

  StreamRange<google::iam::v3::PrincipalAccessBoundaryPolicy>
  ListPrincipalAccessBoundaryPolicies(
      google::iam::v3::ListPrincipalAccessBoundaryPoliciesRequest request)
      override;

  StreamRange<google::iam::v3::PolicyBinding>
  SearchPrincipalAccessBoundaryPolicyBindings(
      google::iam::v3::SearchPrincipalAccessBoundaryPolicyBindingsRequest
          request) override;

  StatusOr<google::longrunning::Operation> GetOperation(
      google::longrunning::GetOperationRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<iam_v3_internal::PrincipalAccessBoundaryPoliciesStub> stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace iam_v3_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_INTERNAL_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_CONNECTION_IMPL_H
