// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/iam/v3/principal_access_boundary_policies_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_INTERNAL_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_LOGGING_DECORATOR_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_INTERNAL_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_LOGGING_DECORATOR_H

#include "google/cloud/iam/v3/internal/principal_access_boundary_policies_stub.h"
#include "google/cloud/tracing_options.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <set>
#include <string>

namespace google {
namespace cloud {
namespace iam_v3_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class PrincipalAccessBoundaryPoliciesLogging
    : public PrincipalAccessBoundaryPoliciesStub {
 public:
  ~PrincipalAccessBoundaryPoliciesLogging() override = default;
  PrincipalAccessBoundaryPoliciesLogging(
      std::shared_ptr<PrincipalAccessBoundaryPoliciesStub> child,
      TracingOptions tracing_options, std::set<std::string> const& components);

  future<StatusOr<google::longrunning::Operation>>
  AsyncCreatePrincipalAccessBoundaryPolicy(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::iam::v3::CreatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> CreatePrincipalAccessBoundaryPolicy(
      grpc::ClientContext& context, Options options,
      google::iam::v3::CreatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::iam::v3::PrincipalAccessBoundaryPolicy>
  GetPrincipalAccessBoundaryPolicy(
      grpc::ClientContext& context, Options const& options,
      google::iam::v3::GetPrincipalAccessBoundaryPolicyRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncUpdatePrincipalAccessBoundaryPolicy(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::iam::v3::UpdatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> UpdatePrincipalAccessBoundaryPolicy(
      grpc::ClientContext& context, Options options,
      google::iam::v3::UpdatePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  future<StatusOr<google::longrunning::Operation>>
  AsyncDeletePrincipalAccessBoundaryPolicy(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::iam::v3::DeletePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> DeletePrincipalAccessBoundaryPolicy(
      grpc::ClientContext& context, Options options,
      google::iam::v3::DeletePrincipalAccessBoundaryPolicyRequest const&
          request) override;

  StatusOr<google::iam::v3::ListPrincipalAccessBoundaryPoliciesResponse>
  ListPrincipalAccessBoundaryPolicies(
      grpc::ClientContext& context, Options const& options,
      google::iam::v3::ListPrincipalAccessBoundaryPoliciesRequest const&
          request) override;

  StatusOr<google::iam::v3::SearchPrincipalAccessBoundaryPolicyBindingsResponse>
  SearchPrincipalAccessBoundaryPolicyBindings(
      grpc::ClientContext& context, Options const& options,
      google::iam::v3::SearchPrincipalAccessBoundaryPolicyBindingsRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> GetOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::GetOperationRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::shared_ptr<PrincipalAccessBoundaryPoliciesStub> child_;
  TracingOptions tracing_options_;
};  // PrincipalAccessBoundaryPoliciesLogging

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace iam_v3_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_INTERNAL_PRINCIPAL_ACCESS_BOUNDARY_POLICIES_LOGGING_DECORATOR_H
