// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/iam/v3/policy_bindings_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_POLICY_BINDINGS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_POLICY_BINDINGS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/iam/v3/policy_bindings_service.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace iam_v3 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class PolicyBindingsConnectionIdempotencyPolicy {
 public:
  virtual ~PolicyBindingsConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<PolicyBindingsConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency CreatePolicyBinding(
      google::iam::v3::CreatePolicyBindingRequest const& request);

  virtual google::cloud::Idempotency GetPolicyBinding(
      google::iam::v3::GetPolicyBindingRequest const& request);

  virtual google::cloud::Idempotency UpdatePolicyBinding(
      google::iam::v3::UpdatePolicyBindingRequest const& request);

  virtual google::cloud::Idempotency DeletePolicyBinding(
      google::iam::v3::DeletePolicyBindingRequest const& request);

  virtual google::cloud::Idempotency ListPolicyBindings(
      google::iam::v3::ListPolicyBindingsRequest request);

  virtual google::cloud::Idempotency SearchTargetPolicyBindings(
      google::iam::v3::SearchTargetPolicyBindingsRequest request);

  virtual google::cloud::Idempotency GetOperation(
      google::longrunning::GetOperationRequest const& request);
};

std::unique_ptr<PolicyBindingsConnectionIdempotencyPolicy>
MakeDefaultPolicyBindingsConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace iam_v3
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_IAM_V3_POLICY_BINDINGS_CONNECTION_IDEMPOTENCY_POLICY_H
