// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/iam/v3/policy_bindings_service.proto
// Original file comments:
// Copyright 2025 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fiam_2fv3_2fpolicy_5fbindings_5fservice_2eproto__INCLUDED
#define GRPC_google_2fiam_2fv3_2fpolicy_5fbindings_5fservice_2eproto__INCLUDED

#include "google/iam/v3/policy_bindings_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/message_allocator.h>
#include <grpcpp/impl/codegen/method_handler.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_callback_handlers.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace google {
namespace iam {
namespace v3 {

// An interface for managing Identity and Access Management (IAM) policy
// bindings.
class PolicyBindings final {
 public:
  static constexpr char const* service_full_name() {
    return "google.iam.v3.PolicyBindings";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a policy binding and returns a long-running operation.
    // Callers will need the IAM permissions on both the policy and target.
    // Once the binding is created, the policy is applied to the target.
    virtual ::grpc::Status CreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreatePolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreatePolicyBindingRaw(context, request, cq));
    }
    // Gets a policy binding.
    virtual ::grpc::Status GetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::google::iam::v3::PolicyBinding* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::PolicyBinding>> AsyncGetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::PolicyBinding>>(AsyncGetPolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::PolicyBinding>> PrepareAsyncGetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::PolicyBinding>>(PrepareAsyncGetPolicyBindingRaw(context, request, cq));
    }
    // Updates a policy binding and returns a long-running operation.
    // Callers will need the IAM permissions on the policy and target in the
    // binding to update, and the IAM permission to remove the existing policy
    // from the binding. Target is immutable and cannot be updated. Once the
    // binding is updated, the new policy is applied to the target.
    virtual ::grpc::Status UpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdatePolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdatePolicyBindingRaw(context, request, cq));
    }
    // Deletes a policy binding and returns a long-running operation.
    // Callers will need the IAM permissions on both the policy and target.
    // Once the binding is deleted, the policy no longer applies to the target.
    virtual ::grpc::Status DeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePolicyBindingRaw(context, request, cq));
    }
    // Lists policy bindings.
    virtual ::grpc::Status ListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::google::iam::v3::ListPolicyBindingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::ListPolicyBindingsResponse>> AsyncListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::ListPolicyBindingsResponse>>(AsyncListPolicyBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::ListPolicyBindingsResponse>> PrepareAsyncListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::ListPolicyBindingsResponse>>(PrepareAsyncListPolicyBindingsRaw(context, request, cq));
    }
    // Search policy bindings by target. Returns all policy binding objects bound
    // directly to target.
    virtual ::grpc::Status SearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::SearchTargetPolicyBindingsResponse>> AsyncSearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::SearchTargetPolicyBindingsResponse>>(AsyncSearchTargetPolicyBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::SearchTargetPolicyBindingsResponse>> PrepareAsyncSearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::SearchTargetPolicyBindingsResponse>>(PrepareAsyncSearchTargetPolicyBindingsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a policy binding and returns a long-running operation.
      // Callers will need the IAM permissions on both the policy and target.
      // Once the binding is created, the policy is applied to the target.
      virtual void CreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a policy binding.
      virtual void GetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest* request, ::google::iam::v3::PolicyBinding* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest* request, ::google::iam::v3::PolicyBinding* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a policy binding and returns a long-running operation.
      // Callers will need the IAM permissions on the policy and target in the
      // binding to update, and the IAM permission to remove the existing policy
      // from the binding. Target is immutable and cannot be updated. Once the
      // binding is updated, the new policy is applied to the target.
      virtual void UpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a policy binding and returns a long-running operation.
      // Callers will need the IAM permissions on both the policy and target.
      // Once the binding is deleted, the policy no longer applies to the target.
      virtual void DeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists policy bindings.
      virtual void ListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest* request, ::google::iam::v3::ListPolicyBindingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest* request, ::google::iam::v3::ListPolicyBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Search policy bindings by target. Returns all policy binding objects bound
      // directly to target.
      virtual void SearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::PolicyBinding>* AsyncGetPolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::PolicyBinding>* PrepareAsyncGetPolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::ListPolicyBindingsResponse>* AsyncListPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::ListPolicyBindingsResponse>* PrepareAsyncListPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::SearchTargetPolicyBindingsResponse>* AsyncSearchTargetPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v3::SearchTargetPolicyBindingsResponse>* PrepareAsyncSearchTargetPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreatePolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreatePolicyBindingRaw(context, request, cq));
    }
    ::grpc::Status GetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::google::iam::v3::PolicyBinding* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::PolicyBinding>> AsyncGetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::PolicyBinding>>(AsyncGetPolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::PolicyBinding>> PrepareAsyncGetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::PolicyBinding>>(PrepareAsyncGetPolicyBindingRaw(context, request, cq));
    }
    ::grpc::Status UpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdatePolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdatePolicyBindingRaw(context, request, cq));
    }
    ::grpc::Status DeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePolicyBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePolicyBindingRaw(context, request, cq));
    }
    ::grpc::Status ListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::google::iam::v3::ListPolicyBindingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::ListPolicyBindingsResponse>> AsyncListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::ListPolicyBindingsResponse>>(AsyncListPolicyBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::ListPolicyBindingsResponse>> PrepareAsyncListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::ListPolicyBindingsResponse>>(PrepareAsyncListPolicyBindingsRaw(context, request, cq));
    }
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::SearchTargetPolicyBindingsResponse>> AsyncSearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::SearchTargetPolicyBindingsResponse>>(AsyncSearchTargetPolicyBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::SearchTargetPolicyBindingsResponse>> PrepareAsyncSearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v3::SearchTargetPolicyBindingsResponse>>(PrepareAsyncSearchTargetPolicyBindingsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest* request, ::google::iam::v3::PolicyBinding* response, std::function<void(::grpc::Status)>) override;
      void GetPolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest* request, ::google::iam::v3::PolicyBinding* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdatePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePolicyBinding(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest* request, ::google::iam::v3::ListPolicyBindingsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest* request, ::google::iam::v3::ListPolicyBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchTargetPolicyBindings(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::CreatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v3::PolicyBinding>* AsyncGetPolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v3::PolicyBinding>* PrepareAsyncGetPolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::GetPolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdatePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePolicyBindingRaw(::grpc::ClientContext* context, const ::google::iam::v3::DeletePolicyBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v3::ListPolicyBindingsResponse>* AsyncListPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v3::ListPolicyBindingsResponse>* PrepareAsyncListPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::ListPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v3::SearchTargetPolicyBindingsResponse>* AsyncSearchTargetPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v3::SearchTargetPolicyBindingsResponse>* PrepareAsyncSearchTargetPolicyBindingsRaw(::grpc::ClientContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePolicyBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPolicyBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePolicyBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePolicyBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPolicyBindings_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchTargetPolicyBindings_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a policy binding and returns a long-running operation.
    // Callers will need the IAM permissions on both the policy and target.
    // Once the binding is created, the policy is applied to the target.
    virtual ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* context, const ::google::iam::v3::CreatePolicyBindingRequest* request, ::google::longrunning::Operation* response);
    // Gets a policy binding.
    virtual ::grpc::Status GetPolicyBinding(::grpc::ServerContext* context, const ::google::iam::v3::GetPolicyBindingRequest* request, ::google::iam::v3::PolicyBinding* response);
    // Updates a policy binding and returns a long-running operation.
    // Callers will need the IAM permissions on the policy and target in the
    // binding to update, and the IAM permission to remove the existing policy
    // from the binding. Target is immutable and cannot be updated. Once the
    // binding is updated, the new policy is applied to the target.
    virtual ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest* request, ::google::longrunning::Operation* response);
    // Deletes a policy binding and returns a long-running operation.
    // Callers will need the IAM permissions on both the policy and target.
    // Once the binding is deleted, the policy no longer applies to the target.
    virtual ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* context, const ::google::iam::v3::DeletePolicyBindingRequest* request, ::google::longrunning::Operation* response);
    // Lists policy bindings.
    virtual ::grpc::Status ListPolicyBindings(::grpc::ServerContext* context, const ::google::iam::v3::ListPolicyBindingsRequest* request, ::google::iam::v3::ListPolicyBindingsResponse* response);
    // Search policy bindings by target. Returns all policy binding objects bound
    // directly to target.
    virtual ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePolicyBinding() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicyBinding(::grpc::ServerContext* context, ::google::iam::v3::CreatePolicyBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPolicyBinding() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetPolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicyBinding(::grpc::ServerContext* context, ::google::iam::v3::GetPolicyBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v3::PolicyBinding>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePolicyBinding() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicyBinding(::grpc::ServerContext* context, ::google::iam::v3::UpdatePolicyBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePolicyBinding() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeletePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicyBinding(::grpc::ServerContext* context, ::google::iam::v3::DeletePolicyBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPolicyBindings() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicyBindings(::grpc::ServerContext* context, ::google::iam::v3::ListPolicyBindingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v3::ListPolicyBindingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchTargetPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchTargetPolicyBindings() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_SearchTargetPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchTargetPolicyBindings(::grpc::ServerContext* context, ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v3::SearchTargetPolicyBindingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreatePolicyBinding<WithAsyncMethod_GetPolicyBinding<WithAsyncMethod_UpdatePolicyBinding<WithAsyncMethod_DeletePolicyBinding<WithAsyncMethod_ListPolicyBindings<WithAsyncMethod_SearchTargetPolicyBindings<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePolicyBinding() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::CreatePolicyBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v3::CreatePolicyBindingRequest* request, ::google::longrunning::Operation* response) { return this->CreatePolicyBinding(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePolicyBinding(
        ::grpc::MessageAllocator< ::google::iam::v3::CreatePolicyBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::CreatePolicyBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPolicyBinding() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::GetPolicyBindingRequest, ::google::iam::v3::PolicyBinding>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v3::GetPolicyBindingRequest* request, ::google::iam::v3::PolicyBinding* response) { return this->GetPolicyBinding(context, request, response); }));}
    void SetMessageAllocatorFor_GetPolicyBinding(
        ::grpc::MessageAllocator< ::google::iam::v3::GetPolicyBindingRequest, ::google::iam::v3::PolicyBinding>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::GetPolicyBindingRequest, ::google::iam::v3::PolicyBinding>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePolicyBinding() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::UpdatePolicyBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v3::UpdatePolicyBindingRequest* request, ::google::longrunning::Operation* response) { return this->UpdatePolicyBinding(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePolicyBinding(
        ::grpc::MessageAllocator< ::google::iam::v3::UpdatePolicyBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::UpdatePolicyBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePolicyBinding() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::DeletePolicyBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v3::DeletePolicyBindingRequest* request, ::google::longrunning::Operation* response) { return this->DeletePolicyBinding(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePolicyBinding(
        ::grpc::MessageAllocator< ::google::iam::v3::DeletePolicyBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::DeletePolicyBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPolicyBindings() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::ListPolicyBindingsRequest, ::google::iam::v3::ListPolicyBindingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v3::ListPolicyBindingsRequest* request, ::google::iam::v3::ListPolicyBindingsResponse* response) { return this->ListPolicyBindings(context, request, response); }));}
    void SetMessageAllocatorFor_ListPolicyBindings(
        ::grpc::MessageAllocator< ::google::iam::v3::ListPolicyBindingsRequest, ::google::iam::v3::ListPolicyBindingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::ListPolicyBindingsRequest, ::google::iam::v3::ListPolicyBindingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicyBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchTargetPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchTargetPolicyBindings() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::SearchTargetPolicyBindingsRequest, ::google::iam::v3::SearchTargetPolicyBindingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* request, ::google::iam::v3::SearchTargetPolicyBindingsResponse* response) { return this->SearchTargetPolicyBindings(context, request, response); }));}
    void SetMessageAllocatorFor_SearchTargetPolicyBindings(
        ::grpc::MessageAllocator< ::google::iam::v3::SearchTargetPolicyBindingsRequest, ::google::iam::v3::SearchTargetPolicyBindingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v3::SearchTargetPolicyBindingsRequest, ::google::iam::v3::SearchTargetPolicyBindingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchTargetPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchTargetPolicyBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreatePolicyBinding<WithCallbackMethod_GetPolicyBinding<WithCallbackMethod_UpdatePolicyBinding<WithCallbackMethod_DeletePolicyBinding<WithCallbackMethod_ListPolicyBindings<WithCallbackMethod_SearchTargetPolicyBindings<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePolicyBinding() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPolicyBinding() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetPolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePolicyBinding() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePolicyBinding() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeletePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPolicyBindings() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchTargetPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchTargetPolicyBindings() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_SearchTargetPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePolicyBinding() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicyBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPolicyBinding() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetPolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicyBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePolicyBinding() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicyBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePolicyBinding() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeletePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicyBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPolicyBindings() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicyBindings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchTargetPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchTargetPolicyBindings() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_SearchTargetPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchTargetPolicyBindings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePolicyBinding() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePolicyBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPolicyBinding() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPolicyBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePolicyBinding() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePolicyBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePolicyBinding() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePolicyBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicyBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPolicyBindings() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPolicyBindings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicyBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchTargetPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchTargetPolicyBindings() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchTargetPolicyBindings(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchTargetPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchTargetPolicyBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePolicyBinding() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v3::CreatePolicyBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v3::CreatePolicyBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreatePolicyBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::CreatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePolicyBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v3::CreatePolicyBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPolicyBinding() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v3::GetPolicyBindingRequest, ::google::iam::v3::PolicyBinding>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v3::GetPolicyBindingRequest, ::google::iam::v3::PolicyBinding>* streamer) {
                       return this->StreamedGetPolicyBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::GetPolicyBindingRequest* /*request*/, ::google::iam::v3::PolicyBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPolicyBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v3::GetPolicyBindingRequest,::google::iam::v3::PolicyBinding>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePolicyBinding() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v3::UpdatePolicyBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v3::UpdatePolicyBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdatePolicyBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::UpdatePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePolicyBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v3::UpdatePolicyBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePolicyBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePolicyBinding() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v3::DeletePolicyBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v3::DeletePolicyBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePolicyBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePolicyBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePolicyBinding(::grpc::ServerContext* /*context*/, const ::google::iam::v3::DeletePolicyBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePolicyBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v3::DeletePolicyBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPolicyBindings() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v3::ListPolicyBindingsRequest, ::google::iam::v3::ListPolicyBindingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v3::ListPolicyBindingsRequest, ::google::iam::v3::ListPolicyBindingsResponse>* streamer) {
                       return this->StreamedListPolicyBindings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::ListPolicyBindingsRequest* /*request*/, ::google::iam::v3::ListPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPolicyBindings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v3::ListPolicyBindingsRequest,::google::iam::v3::ListPolicyBindingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchTargetPolicyBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchTargetPolicyBindings() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v3::SearchTargetPolicyBindingsRequest, ::google::iam::v3::SearchTargetPolicyBindingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v3::SearchTargetPolicyBindingsRequest, ::google::iam::v3::SearchTargetPolicyBindingsResponse>* streamer) {
                       return this->StreamedSearchTargetPolicyBindings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchTargetPolicyBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchTargetPolicyBindings(::grpc::ServerContext* /*context*/, const ::google::iam::v3::SearchTargetPolicyBindingsRequest* /*request*/, ::google::iam::v3::SearchTargetPolicyBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchTargetPolicyBindings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v3::SearchTargetPolicyBindingsRequest,::google::iam::v3::SearchTargetPolicyBindingsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreatePolicyBinding<WithStreamedUnaryMethod_GetPolicyBinding<WithStreamedUnaryMethod_UpdatePolicyBinding<WithStreamedUnaryMethod_DeletePolicyBinding<WithStreamedUnaryMethod_ListPolicyBindings<WithStreamedUnaryMethod_SearchTargetPolicyBindings<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreatePolicyBinding<WithStreamedUnaryMethod_GetPolicyBinding<WithStreamedUnaryMethod_UpdatePolicyBinding<WithStreamedUnaryMethod_DeletePolicyBinding<WithStreamedUnaryMethod_ListPolicyBindings<WithStreamedUnaryMethod_SearchTargetPolicyBindings<Service > > > > > > StreamedService;
};

}  // namespace v3
}  // namespace iam
}  // namespace google


#endif  // GRPC_google_2fiam_2fv3_2fpolicy_5fbindings_5fservice_2eproto__INCLUDED
